/*
  500000ANZXLOEz}V

            2002/ 6/24 ˁ@P
*/
#include <windows.h>
#include "win32.h"
#include <stdexcept>
using namespace std;

class CMemory { // VXeNX

public:

	CMemory(UI32);

	UI8 read8(UI32) const;
	UI16 read16(UI32) const;
	UI32 read32(UI32) const;
	bool write8(UI32,UI8);
	bool write16(UI32,UI16);
	bool write32(UI32,UI32);

	~CMemory();

private:

	I32 i32MemSize;
	UI32 u32LastAddress;
	BUF bfMemory;

	bool clear();

};

class CVCPU { // zCPUC^[tF[XNX

public:

	virtual bool exec()=0;
	virtual UI32 getRegister(I32) const=0;
	virtual UI32 getPC() const=0;
	virtual UI32 getSP() const=0;
	virtual bool getSRZero() const=0;
	virtual bool getSRSig() const=0;
	virtual bool getSROF() const=0;
 
	virtual ~CVCPU() {}

};

class CCpu:public CVCPU { // zCPUNX

public:

	CCpu(CMemory *,UI32);

	bool reset();

	virtual bool exec() throw(logic_error);

	virtual UI32 getRegister(I32) const;
	virtual UI32 getPC() const;
	virtual UI32 getSP() const;
	virtual UI32 getSR() const;
	virtual bool getSRZero() const;
	virtual bool getSRSig() const;
	virtual bool getSROF() const;

	virtual bool setRegister(I32,UI32);
	virtual bool setPC(UI32);
	virtual bool setSP(UI32);
	virtual bool setSR(UI32);

	virtual ~CCpu();

private:

	UI32 u32Reg[16];
	UI32 GR_LAST_INDEX,REG_SP,REG_SR,REG_PC,SR_ZERO,SR_SIG,SR_OF;
	CMemory *pmMemory;

	bool exec(UI32);

};

class CVm { // z}VNX

public:

	CVm();

	CVCPU * getCpu();
	CMemory * getMemory();

	bool step();

	~CVm();

private:

	CVCPU *pcpCpu;
	CMemory *pmMemory;

};
