#include "classes.h"

CVm::CVm() {

	pmMemory=new CMemory(256);
	pcpCpu=new CCpu(pmMemory,0);

	pmMemory->write32(0x00,0x00010030);
	pmMemory->write32(0x04,0x00030100);
	pmMemory->write32(0x08,0x12345678);
	pmMemory->write32(0x0c,0x00090001);
	pmMemory->write32(0x10,0x00040100);
	pmMemory->write32(0x14,0x00050100);
	pmMemory->write32(0x18,0x00060100);

}

CVCPU * CVm::getCpu() { return pcpCpu; }
CMemory * CVm::getMemory() { return pmMemory; }

bool CVm::step() {

	try {
		pcpCpu->exec();
	} catch (logic_error e) {

		MessageBox(NULL,e.what(),"G[",MB_OK);
		return false;

	}

	return true;

}

CVm::~CVm() {

	delete pcpCpu;
	delete pmMemory;

}
